%     VIRTUAL SORIC - программа для получения эффективных свойств заполнителей SORIC
%     Copyright (C) 2020  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Material_Properties = Heat_Transfer_Procedure(Work_Directory, CPU, NODES, ELEMENTS, Material_Properties, RVE_Coordinates, Node_Merge_Tolerance, V_resin_cell, V_resin_total, Shell_Layer)

global ErrCode;

File_Name = '_Results_Heat_Transfer.txt';

% --- Удаление файла с предыдущими результатами ---

if (exist(File_Name, 'file') == 2)
    delete(File_Name);
end

% --- Осреднение плотности ячейки периодичности ---

fprintf (1, 'Осреднение плотности...                                 ');

Density = Density_Homogenization(Material_Properties, V_resin_total);

fprintf (1, 'OK!\n');

% --- Осреднение удельной теплоемкости ячейки периодичности ---

fprintf (1, 'Осреднение удельной теплоемкости...                     ');

Cp = Specific_Heat_Homogenization(Material_Properties, V_resin_total);

fprintf (1, 'OK!\n');

% --- Осреднение шестиугольной ячейки ---

fprintf (1, 'Осреднение шестиугольной ячейки...                      ');

Material_Properties = Compute_Cell_Therm_Props(Material_Properties, V_resin_cell);

fprintf (1, 'OK!\n');

% --- Создание .inp файла для теплового расчета ---

fprintf (1, 'Создание .inp файла для теплового расчета...            ');

Job_Name = 'Virtual_Soric_thermal';

Write_Input_Thermal(Job_Name, Work_Directory, NODES, ELEMENTS, Material_Properties, RVE_Coordinates, Node_Merge_Tolerance, Shell_Layer);

if (ErrCode < 0)
    return;
end

fprintf (1, 'OK!\n');

% --- Удаление старого файла Job_Name.dat ---

if (exist([Work_Directory '\' Job_Name '.dat'], 'file') == 2)
    delete([Work_Directory '\' Job_Name '.dat']);
end

% --- Решение задачи в Abaqus ---

fprintf (1, 'Решение задачи в Abaqus...                              ');

% Команда для запуска решателя
if (CPU > 1)
    Abaqus_Command = sprintf('abaqus job=%s cpus=%i ask_delete="OFF" -seq', Job_Name, CPU);
else
    Abaqus_Command = sprintf('abaqus job=%s ask_delete="OFF" -seq', Job_Name);
end

% Смена текущей папки на рабочую папку
Current_Folder = cd(Work_Directory);

% Запуск решателя
[status,cmdout] = system(Abaqus_Command);

if (~isempty(cmdout))
    fprintf(1, '\nПредупреждение! Непустая переменная cmdout после вызова решателя:\n[%s]\n', strtrim(cmdout));
end

% Возврат к старой папке
cd(Current_Folder);

% Проверка status
if (status ~= 0)
    fprintf (1, '\nВыполнение команды [%s]\nзавершилось с ошибкой!\n', Abaqus_Command);
    fprintf (1, '------------------------------------------------------------------------------------\n');
    fprintf (1, '%s\n', cmdout);
    fprintf (1, '------------------------------------------------------------------------------------\n');
    ErrCode = -1;
    return;
end

% Пауза для закрытия всех файлов решателем
pause(3);

fprintf (1, 'OK!\n');

% --- Чтение результатов ---

fprintf (1, 'Чтение результатов...                                   ');

Results_Thermal = Read_Dat_File_Therm(Job_Name, Work_Directory, ELEMENTS, []);

if (ErrCode < 0)
    return;
end

fprintf (1, 'OK!\n');

% --- Осреднение теплопроводности ---

fprintf (1, 'Осреднение теплопроводности...                          ');

Lambda = Conductivity_Homogenization(Results_Thermal, RVE_Coordinates);

fprintf (1, 'OK!\n');

% --- Запись результатов ---

fprintf (1, 'Запись эффективных свойств...                           ');

Write_Result_File_Therm(Current_Folder, File_Name, Density, Cp, Lambda);

if (ErrCode < 0)
    return;
end

fprintf (1, 'OK!\n');

% Сообщение об успешном создании файла с результатами
fprintf (1, '\n    Файл [%s] создан успешно!\n', [Current_Folder '\' File_Name]);
